> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trysoma.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create provider

> Create a new provider instance with the specified configuration



## OpenAPI

````yaml api-reference/openapi.json post /api/bridge/v1/available-providers/{provider_controller_type_id}/available-credentials/{credential_controller_type_id}
openapi: 3.1.0
info:
  title: soma
  version: v1
servers: []
security: []
tags:
  - name: task
    description: >-
      Task management endpoints for creating, listing, and managing tasks and
      their messages
  - name: secret
    description: Secret management endpoints for storing and retrieving encrypted secrets
  - name: encryption
    description: >-
      Encryption key management endpoints for envelope keys, data encryption
      keys, and aliases
  - name: bridge
    description: >-
      Bridge endpoints for managing providers, credentials, functions, and MCP
      protocol communication
  - name: _internal
    description: >-
      Internal endpoints for health checks, runtime configuration, and SDK code
      generation
  - name: a2a
    description: >-
      Agent-to-agent communication endpoints for agent cards, definitions, and
      JSON-RPC requests
  - name: v1
    description: API version v1 endpoints
paths:
  /api/bridge/v1/available-providers/{provider_controller_type_id}/available-credentials/{credential_controller_type_id}:
    post:
      tags:
        - bridge
        - v1
      summary: Create provider
      description: Create a new provider instance with the specified configuration
      operationId: create-provider-instance
      parameters:
        - name: provider_controller_type_id
          in: path
          required: true
          schema:
            type: string
        - name: credential_controller_type_id
          in: path
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateProviderInstanceParamsInner'
        required: true
      responses:
        '200':
          description: Create provider instance
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProviderInstanceSerialized'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
components:
  schemas:
    CreateProviderInstanceParamsInner:
      type: object
      required:
        - resource_server_credential_id
        - display_name
      properties:
        display_name:
          type: string
        provider_instance_id:
          type:
            - string
            - 'null'
        resource_server_credential_id:
          $ref: '#/components/schemas/WrappedUuidV4'
        return_on_successful_brokering:
          oneOf:
            - type: 'null'
            - $ref: '#/components/schemas/ReturnAddress'
        user_credential_id:
          oneOf:
            - type: 'null'
            - $ref: '#/components/schemas/WrappedUuidV4'
    ProviderInstanceSerialized:
      type: object
      required:
        - id
        - display_name
        - resource_server_credential_id
        - created_at
        - updated_at
        - provider_controller_type_id
        - credential_controller_type_id
        - status
      properties:
        created_at:
          $ref: '#/components/schemas/WrappedChronoDateTime'
        credential_controller_type_id:
          type: string
        display_name:
          type: string
        id:
          type: string
        provider_controller_type_id:
          type: string
        resource_server_credential_id:
          $ref: '#/components/schemas/WrappedUuidV4'
        return_on_successful_brokering:
          oneOf:
            - type: 'null'
            - $ref: '#/components/schemas/ReturnAddress'
        status:
          type: string
        updated_at:
          $ref: '#/components/schemas/WrappedChronoDateTime'
        user_credential_id:
          oneOf:
            - type: 'null'
            - $ref: '#/components/schemas/WrappedUuidV4'
    Error:
      type: object
      required:
        - message
      properties:
        data: {}
        message:
          type: string
    WrappedUuidV4:
      type: string
      format: uuid
    ReturnAddress:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/ReturnAddressUrl'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - url
    WrappedChronoDateTime:
      type: string
      format: date-time
    ReturnAddressUrl:
      type: object
      required:
        - url
      properties:
        url:
          type: string

````